'use strict';

function onJDSTARNowReceiveUpdateHeardEntries(data) {
    $(data).each((index, entry) =>{
        onJDSTARNowReceiveUpdateHeardEntry(entry);
    });
}

function onJDSTARNowReceiveUpdateHeardEntry(data) {
    logger.trace(data);

    const heardlog = $("#jdstarnow_heard_entries");
    if(!heardlog.exists()){
        logger.error("HeardLog not found.");
        return;
    }
	
	const validPos =
		(data.latitude >= -90 && data.latitude <= +90) &&
		(data.longitude >= -180 && data.longitude <= +180);

    let entry =
        $(heardlog).find("td[name='myLong']")
        .find("a")
        .filter(function() {
            return $(this).text() === data.myCallsign;
        }).parent();
    if(entry.exists()){
        entry = entry.parent();
        
        entry.find("[name='time']").text(
            moment.unix(data.time / 1000).format("MM/DD HH:mm:ss")
        );
        entry.find("[name='repeaterName']").text(data.repeaterName);
        entry.find("[name='rpt1']").text(data.repeater1Callsign);
        entry.find("[name='rpt2']").text(data.repeater2Callsign);
        entry.find("[name='your']").text(data.yourCallsign);

        entry.find("[name='myShort']").text(data.myCallsignSuffix);
        entry.find("[name='message']").text(data.message);
        entry.find("[name='position']>a")
            .text(validPos ? '[Map]' : '')
            .attr('href', ('https://www.google.com/maps?q=' + data.latitude + ',' + data.longitude));

        $(entry).prependTo($(entry).parent());
    }
    else {
        const regResult = data.myCallsign.match(/^([A-Z0-9]{4,7})/g);
        const myCallsignNoModule = regResult != null && regResult.length >= 1 && regResult[0] ? regResult[0] : null;
        entry =
            $('<tr />').loadTemplate($("#template_jdstarnow_heard_entry"),{
                "index":0,
                "time":moment.unix(data.time / 1000).format("MM/DD HH:mm:ss"),
                "rptName":data.repeaterName,
                "rpt1":data.repeater1Callsign,
                "rpt2":data.repeater2Callsign,
                "your":data.yourCallsign,
                "myLong":data.myCallsign,
                "myLongLink":myCallsignNoModule ? 'https://www.qrz.com/db/' + myCallsignNoModule : "#",
                "myShort":data.myCallsignSuffix,
                "message":data.message,
                "position":(validPos ? '[Map]' : ''),
                "positionLink":(validPos ? ('https://www.google.com/maps?q=' + data.latitude + ',' + data.longitude) : '')
            });
        heardlog.prepend(entry);
    }

    const myLongCallsignLink = $(entry).find('td[name="myLong"]>a');
    const positionLink = $(entry).find("[name='position']>a");
    if(data.transmitting){
        $(entry).addClass('table-success');
        $(entry).addClass('text-dark');
        $(entry).addClass('font-weight-bold');
        if(myLongCallsignLink.exists()){
            myLongCallsignLink.removeClass('text-light');
            myLongCallsignLink.addClass('text-danger');
        }
        if(positionLink.exists()){
            positionLink.removeClass('text-light');
            positionLink.addClass('text-danger');
        }
    }
    else{
        $(entry).removeClass('table-success');
        $(entry).removeClass('text-dark');
        $(entry).removeClass('font-weight-bold');
        if(myLongCallsignLink.exists()){
            myLongCallsignLink.addClass('text-light');
            myLongCallsignLink.removeClass('text-danger');
        }
        if(positionLink.exists()){
            positionLink.addClass('text-light');
            positionLink.removeClass('text-danger');
        }
    }

    const indexEntries = $(heardlog).find("th[name='index']");
    indexEntries.each(function(index, entry){
        if(index < dstarnowLimit)
            $(entry).text(index + 1);
        else
            $(entry).parent().remove();
    });
}
